/**
 * Vare.java
 * Modifisert utgave av klassen Vare, side 186.
 */

class Vare {
  public static final double MOMS = 24.0;
  public static final double MOMSFAKTOR = 1.0 + MOMS / 100.0;
  public static final int BESTILLINGSFAKTOR = 4;

  private final String varenavn;
  private final int varenr;
  private double pris; // pris pr. enhet
  private int pLager;
  private int grense; // for bestilling

  public Vare(String varenavn, int varenr, double pris, int pLager, int grense) {
    this.varenavn = varenavn;
    this.varenr = varenr;
    this.pris = pris;
    this.pLager = pLager;
    this.grense = grense;
  }

  public Vare(String varenavn, int varenr, int pLager, int grense) {
    this(varenavn, varenr, 0.0, pLager, grense);
  }

  public String getVarenavn() {
    return varenavn;
  }

  public int getVarenr() {
    return varenr;
  }

  public double getPris() {
    return pris;
  }

  public void setPris(double pris) {
    this.pris = pris;
  }

  public int getGrense() {
    return grense;
  }

  public void setGrense(int nyGrense) {
    grense = nyGrense;
  }

  public int getPLager() {
    return pLager;
  }

  public void setPLager(int nyPLager) {
    pLager = nyPLager;
  }

  public int finnBestKvantum() {
    return (pLager < grense) ? BESTILLINGSFAKTOR * grense : 0;
  }

  /**
   * Endring av lagerbeholdning.
   * Den kan vre positiv eller negativ. Men det er ikke
   * mulig  ta ut mer enn det som fins p lager. Hvis klienten
   * prver p det, vil metoden returnere false, og intet uttak gjres.
   */
  public boolean endreLagerbeholdning(int endring) {
    if (pLager + endring < 0) {
      return false;
    } else {
      pLager += endring;
      return true;
    }
  }

  public String toString() {
    java.util.Formatter f = new java.util.Formatter();
    f.format("%.2f", pris);
    return varenr + ": " + varenavn + ", pris pr. enhet kr " + f.toString() + " u.moms.\n"
                         + "Antall p lager: " + pLager + ", nedre grense for bestilling: " + grense + ".";
  }
}